(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

/* harmony default export */ __webpack_exports__["a"] = ({
	name: 'OSUpload',
	props: {
		// 自定义样式
		boxStyle: {
			type: Object,
			default() {
				return {};
			}
		},
		// 绑定元素
		dom: {
			type: String,
			required: true
		},
		// 图片高度
		height: {
			type: Number,
			default: 0
		},
		// 图片宽度
		width: {
			type: Number,
			default: 0
		},
		// 自定义图片命名
		customName: {
			type: String,
			default: ''
		},
		// 图片大小(M)
		size: {
			type: Number,
			default: 4
		},
		// 压缩百分比
		ratio: {
			type: Number,
			default: 0.75
		},
		// oss路径
		ossDir: {
			type: String,
			required: true
		},
		// 获取签名接口
		getSgin: {
			type: String,
			required: true
		},
		// 添加图片图标
		addIcon: {
			type: String,
			default: 'https://img.niaocdn.com/i1/icn_img_upload.png'
		},
		// 加载图片
		loadding: {
			type: String,
			default: 'https://img.niaocdn.com/i1/loadding.gif'
		}
	},
	computed: {
		isShow() {
			let a = true;
			if (this.imgUrl !== '') {
				a = false;
			} else {
				a = true;
			}
			return a;
		}
	},
	methods: {
		// 触发选择按钮
		chooseFile() {
			document.getElementById(this.dom).click();
		},
		// file按钮改变事件
		fileChange(e) {
			let files = e.target.files || e.dataTransfer.files;
			// 如果文件个数为零，则直接返回
			if (!files.length) return;
			// 判断文件大小是否符合要求
			let img = files[0];
			if (this.size !== 0 && (img.size / (1024 * 1024)).toFixed(2) > this.size) {
				this.$Message.warning(img.name + '大于' + this.size + 'M，无法上传');
			} else {
				// 将文件加入队列
				this.fileList(files);
				// 清空原来的值，用于再次点击上传
				e.target.value = '';
			}
		},
		// 将文件加入队列
		fileList(files) {
			// 先添加加载图片
			this.imgUrl = this.loadding;
			// 进行文件添加
			this.fileAdd(files[0]);
		},
		// 进行文件添加
		fileAdd(file) {
			// 记录this
			let self = this;
			// 创建一个reader
			let reader = new FileReader();
			// 将图片转成base64格式
			reader.readAsDataURL(file);
			// 读取成功后的回调
			reader.onloadend = function () {
				// 建立图像对象
				let image = new Image();
				// 获取回调结果
				let result = this.result;
				// 获取时间戳字符串用于图片命名
				let dateStr = new Date().getTime().toString().substr(7);
				// 给图像赋值src
				image.src = result;
				// 如果存在自定义名称，则使用自定义名称，只在上传一张图片时有效
				if (self.customName !== '') {
					image.name = self.customName + self.getSuffix(file.name);
				} else {
					image.name = self.randomString(10) + dateStr + self.getSuffix(file.name);
				}
				// 图片渲染加载
				image.onload = function () {
					// 对图片进行压缩
					let data = self.compress(image);
					// 将图片进行base64转blob对象
					let blob = self.dataURItoBlob(data);
					// 进行签名和上传操作
					self.getSign(image.name, blob);
				};
			};
		},
		// 调用获取签名接口
		getSign(key, blob) {
			// 判断当前expire是否超时，3s 作为缓冲
			let expire = 0;
			let now = Date.parse(new Date()) / 1000;
			if (expire < now + 30) {
				this.$axios.post(this.getSgin).then(res => {
					this.handleUpload(res.data.data, key, blob);
				}).catch(error => {
					alert(error);
				});
			} else {
				return false;
			}
		},
		// 设置上传参数
		handleUpload(obj, key, blob) {
			let params = new FormData();
			let name = obj.dir + '/' + this.ossDir + '/' + key;
			params.append('key', name);
			params.append('policy', obj.policy);
			params.append('OSSAccessKeyId', obj.accessid);
			params.append('success_action_status', '200');
			params.append('signature', obj.signature);
			params.append('file', blob);
			// 配置图片上传头信息
			let config = {
				headers: { 'Content-Type': 'multipart/form-data' }
				// 进行ajax上传
			};this.$axios.post(obj.host, params, config).then(res => {
				if (res.status === 200) {
					// OSS上传成功后将服务器返回的图片地址替换原有地址
					this.imgUrl = obj.cdn + '/' + name + '?t=' + Math.random();
				} else {
					alert(res.statusText);
				}
			}).catch(error => {
				alert(error);
			});
		},
		// 对图片进行压缩
		compress(img) {
			let canvas = document.createElement('canvas');
			let ctx = canvas.getContext('2d');
			let width = img.width;
			let height = img.height;
			// 进行生成图片尺寸计算
			if (this.width > 0 && width > this.width) {
				// 限定宽度
				canvas.width = this.width;
				canvas.height = height * (this.width / width);
			} else if (this.height > 0 && height > this.height) {
				// 限定高度
				canvas.height = this.height;
				canvas.width = width * (this.height / height);
			} else {
				// 不限定尺寸
				canvas.width = width;
				canvas.height = height;
			}
			// 铺底色
			ctx.fillStyle = '#fff';
			ctx.fillRect(0, 0, canvas.width, canvas.height);
			ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
			// 进行最小压缩
			let ndata = canvas.toDataURL('image/jpeg', this.ratio);
			return ndata;
		},
		// base64转成bolb对象
		dataURItoBlob(base64Data) {
			var byteString;
			if (base64Data.split(',')[0].indexOf('base64') >= 0) {
				byteString = atob(base64Data.split(',')[1]);
			} else {
				byteString = unescape(base64Data.split(',')[1]);
			}
			var mimeString = base64Data.split(',')[0].split(':')[1].split(';')[0];
			var ia = new Uint8Array(byteString.length);
			for (var i = 0; i < byteString.length; i++) {
				ia[i] = byteString.charCodeAt(i);
			}
			return new Blob([ia], { type: mimeString });
		},
		// 生成随机字符串，用于图片命名
		randomString(len) {
			len = len || 32;
			var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
			var maxPos = chars.length;
			var pwd = '';
			for (let i = 0; i < len; i++) {
				pwd += chars.charAt(Math.floor(Math.random() * maxPos));
			}
			return pwd;
		},
		// 获取文件扩展名
		getSuffix(filename) {
			let pos = filename.lastIndexOf('.');
			let suffix = '';
			if (pos !== -1) {
				suffix = filename.substring(pos);
			}
			return suffix.toLowerCase();
		}
	},
	data() {
		return {
			imgUrl: ''
		};
	}
});

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__app_vue__ = __webpack_require__(2);

/* harmony default export */ __webpack_exports__["default"] = (__WEBPACK_IMPORTED_MODULE_0__app_vue__["a" /* default */]);

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_app_vue__ = __webpack_require__(0);
/* unused harmony namespace reexport */
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_5ef48958_hasScoped_true_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_app_vue__ = __webpack_require__(9);
var disposed = false
function injectStyle (ssrContext) {
  if (disposed) return
  __webpack_require__(3)
}
var normalizeComponent = __webpack_require__(8)
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-5ef48958"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null
var Component = normalizeComponent(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_app_vue__["a" /* default */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_5ef48958_hasScoped_true_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_app_vue__["a" /* default */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/app.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-5ef48958", Component.options)
  } else {
    hotAPI.reload("data-v-5ef48958", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["a"] = (Component.exports);


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(4);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var update = __webpack_require__(6)("0695537d", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../node_modules/css-loader/index.js?sourceMap!../node_modules/vue-loader/lib/style-compiler/index.js?{\"vue\":true,\"id\":\"data-v-5ef48958\",\"scoped\":true,\"hasInlineConfig\":false}!../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./app.vue", function() {
     var newContent = require("!!../node_modules/css-loader/index.js?sourceMap!../node_modules/vue-loader/lib/style-compiler/index.js?{\"vue\":true,\"id\":\"data-v-5ef48958\",\"scoped\":true,\"hasInlineConfig\":false}!../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./app.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(5)(true);
// imports


// module
exports.push([module.i, "\n.z_up-btn[data-v-5ef48958] {\n\tposition: relative;\n\tdisplay: flex;\n\tjustify-content: center;\n\talign-items: center;\n\tmin-height: 100px;\n\tborder: 1px solid #dcdee2;\n\tcursor: pointer;\n}\n.z_up-btn img[data-v-5ef48958] {\n\tmax-width: 100%;\n\tmax-height: 100%;\n}\n.z_add-btn[data-v-5ef48958] {\n\tposition: absolute;\n\ttop: 0;\n\tleft: 0;\n\tright: 0;\n\tbottom: 0;\n\tz-index: 99;\n}\n.z_add-tips[data-v-5ef48958] {\n\tfont-size: 14px;\n\tcolor: #ccc;\n}\n", "", {"version":3,"sources":["D:/npm/upload/src/src/app.vue"],"names":[],"mappings":";AA4QA;CACA,mBAAA;CACA,cAAA;CACA,wBAAA;CACA,oBAAA;CACA,kBAAA;CACA,0BAAA;CACA,gBAAA;CACA;AACA;CACA,gBAAA;CACA,iBAAA;CACA;AACA;CACA,mBAAA;CACA,OAAA;CACA,QAAA;CACA,SAAA;CACA,UAAA;CACA,YAAA;CACA;AACA;CACA,gBAAA;CACA,YAAA;CACA","file":"app.vue","sourcesContent":["<template>\r\n\t<div>\r\n\t\t<div class=\"z_up-btn\" :style=\"boxStyle\">\r\n\t\t\t<div class=\"z_add-btn\" @click=\"chooseFile\">\r\n\t\t\t\t<input\r\n\t\t\t\t@change=\"fileChange($event)\"\r\n\t\t\t\ttype=\"file\"\r\n\t\t\t\t:id=\"dom\"\r\n\t\t\t\taccept=\"image/*\"\r\n\t\t\t\tstyle=\"display: none\"\r\n\t\t\t\t/>\r\n\t\t\t</div>\r\n\t\t\t<img :src=\"addIcon\" v-if=\"isShow\" >\r\n\t\t\t<img :src=\"imgUrl\" alt=\"图片数据丢失\" v-if=\"!isShow\">\r\n\t\t</div>\r\n\t</div>\r\n</template>\r\n\r\n<script>\r\n\texport default {\r\n\t\tname: 'OSUpload',\r\n\t\tprops: {\r\n\t\t\t// 自定义样式\r\n\t\t\tboxStyle: {\r\n\t\t\t\ttype: Object,\r\n\t\t\t\tdefault () {\r\n\t\t\t\t\treturn {}\r\n\t\t\t\t}\r\n\t\t\t},\r\n\t\t\t// 绑定元素\r\n\t\t\tdom: {\r\n\t\t\t\ttype: String,\r\n\t\t\t\trequired: true\r\n\t\t\t},\r\n\t\t\t// 图片高度\r\n\t\t\theight: {\r\n\t\t\t\ttype: Number,\r\n\t\t\t\tdefault: 0\r\n\t\t\t},\r\n\t\t\t// 图片宽度\r\n\t\t\twidth: {\r\n\t\t\t\ttype: Number,\r\n\t\t\t\tdefault: 0\r\n\t\t\t},\r\n\t\t\t// 自定义图片命名\r\n\t\t\tcustomName: {\r\n\t\t\t\ttype: String,\r\n\t\t\t\tdefault: ''\r\n\t\t\t},\r\n\t\t\t// 图片大小(M)\r\n\t\t\tsize: {\r\n\t\t\t\ttype: Number,\r\n\t\t\t\tdefault: 4\r\n\t\t\t},\r\n\t\t\t// 压缩百分比\r\n\t\t\tratio: {\r\n\t\t\t\ttype: Number,\r\n\t\t\t\tdefault: 0.75\r\n\t\t\t},\r\n\t\t\t// oss路径\r\n\t\t\tossDir: {\r\n\t\t\t\ttype: String,\r\n\t\t\t\trequired: true\r\n\t\t\t},\r\n\t\t\t// 获取签名接口\r\n\t\t\tgetSgin: {\r\n\t\t\t\ttype: String,\r\n\t\t\t\trequired: true\r\n\t\t\t},\r\n\t\t\t// 添加图片图标\r\n\t\t\taddIcon: {\r\n\t\t\t\ttype: String,\r\n\t\t\t\tdefault: 'https://img.niaocdn.com/i1/icn_img_upload.png'\r\n\t\t\t},\r\n\t\t\t// 加载图片\r\n\t\t\tloadding: {\r\n\t\t\t\ttype: String,\r\n\t\t\t\tdefault: 'https://img.niaocdn.com/i1/loadding.gif'\r\n\t\t\t}\r\n\t\t},\r\n\t\tcomputed: {\r\n\t\t\tisShow () {\r\n\t\t\t\tlet a = true\r\n\t\t\t\tif (this.imgUrl !== '') {\r\n\t\t\t\t\ta = false\r\n\t\t\t\t} else {\r\n\t\t\t\t\ta = true\r\n\t\t\t\t}\r\n\t\t\t\treturn a\r\n\t\t\t}\r\n\t\t},\r\n\t\tmethods: {\r\n\t\t\t// 触发选择按钮\r\n\t\t\tchooseFile () {\r\n\t\t\t\tdocument.getElementById(this.dom).click()\r\n\t\t\t},\r\n\t\t\t// file按钮改变事件\r\n\t\t\tfileChange (e) {\r\n\t\t\t\tlet files = e.target.files || e.dataTransfer.files\r\n\t\t\t\t// 如果文件个数为零，则直接返回\r\n\t\t\t\tif (!files.length) return\r\n\t\t\t\t// 判断文件大小是否符合要求\r\n\t\t\t\tlet img = files[0]\r\n\t\t\t\tif (this.size !== 0 && (img.size / (1024 * 1024)).toFixed(2) > this.size) {\r\n\t\t\t\t\tthis.$Message.warning(img.name + '大于' + this.size + 'M，无法上传')\r\n\t\t\t\t} else {\r\n\t\t\t\t\t// 将文件加入队列\r\n\t\t\t\t\tthis.fileList(files)\r\n\t\t\t\t\t// 清空原来的值，用于再次点击上传\r\n\t\t\t\t\te.target.value = ''\r\n\t\t\t\t}\r\n\t\t\t},\r\n\t\t\t// 将文件加入队列\r\n\t\t\tfileList (files) {\r\n\t\t\t\t// 先添加加载图片\r\n\t\t\t\tthis.imgUrl = this.loadding\r\n\t\t\t\t// 进行文件添加\r\n\t\t\t\tthis.fileAdd(files[0])\r\n\t\t\t},\r\n\t\t\t// 进行文件添加\r\n\t\t\tfileAdd (file) {\r\n\t\t\t\t// 记录this\r\n\t\t\t\tlet self = this\r\n\t\t\t\t// 创建一个reader\r\n\t\t\t\tlet reader = new FileReader()\r\n\t\t\t\t// 将图片转成base64格式\r\n\t\t\t\treader.readAsDataURL(file)\r\n\t\t\t\t// 读取成功后的回调\r\n\t\t\t\treader.onloadend = function () {\r\n\t\t\t\t\t// 建立图像对象\r\n\t\t\t\t\tlet image = new Image()\r\n\t\t\t\t\t// 获取回调结果\r\n\t\t\t\t\tlet result = this.result\r\n\t\t\t\t\t// 获取时间戳字符串用于图片命名\r\n\t\t\t\t\tlet dateStr = new Date().getTime().toString().substr(7)\r\n\t\t\t\t\t// 给图像赋值src\r\n\t\t\t\t\timage.src = result\r\n\t\t\t\t\t// 如果存在自定义名称，则使用自定义名称，只在上传一张图片时有效\r\n\t\t\t\t\tif (self.customName !== '') {\r\n\t\t\t\t\t\timage.name = self.customName + self.getSuffix(file.name)\r\n\t\t\t\t\t} else {\r\n\t\t\t\t\t\timage.name = self.randomString(10) + dateStr + self.getSuffix(file.name)\r\n\t\t\t\t\t}\r\n\t\t\t\t\t// 图片渲染加载\r\n\t\t\t\t\timage.onload = function () {\r\n\t\t\t\t\t\t// 对图片进行压缩\r\n\t\t\t\t\t\tlet data = self.compress(image)\r\n\t\t\t\t\t\t// 将图片进行base64转blob对象\r\n\t\t\t\t\t\tlet blob = self.dataURItoBlob(data)\r\n\t\t\t\t\t\t// 进行签名和上传操作\r\n\t\t\t\t\t\tself.getSign(image.name, blob)\r\n\t\t\t\t\t}\r\n\t\t\t\t}\r\n\t\t\t},\r\n\t\t\t// 调用获取签名接口\r\n\t\t\tgetSign (key, blob) {\r\n\t\t\t\t// 判断当前expire是否超时，3s 作为缓冲\r\n\t\t\t\tlet expire = 0\r\n\t\t\t\tlet now = Date.parse(new Date()) / 1000\r\n\t\t\t\tif (expire < now + 30) {\r\n\t\t\t\t\tthis.$axios.post(this.getSgin).then(res => {\r\n\t\t\t\t\t\tthis.handleUpload(res.data.data, key, blob)\r\n\t\t\t\t\t}).catch(error => {\r\n\t\t\t\t\t\talert(error)\r\n\t\t\t\t\t})\r\n\t\t\t\t} else {\r\n\t\t\t\t\treturn false\r\n\t\t\t\t}\r\n\t\t\t},\r\n\t\t\t// 设置上传参数\r\n\t\t\thandleUpload (obj, key, blob) {\r\n\t\t\t\tlet params = new FormData()\r\n\t\t\t\tlet name = obj.dir + '/' + this.ossDir + '/' + key\r\n\t\t\t\tparams.append('key', name)\r\n\t\t\t\tparams.append('policy', obj.policy)\r\n\t\t\t\tparams.append('OSSAccessKeyId', obj.accessid)\r\n\t\t\t\tparams.append('success_action_status', '200')\r\n\t\t\t\tparams.append('signature', obj.signature)\r\n\t\t\t\tparams.append('file', blob)\r\n\t\t\t\t// 配置图片上传头信息\r\n\t\t\t\tlet config = {\r\n\t\t\t\t\theaders: {'Content-Type': 'multipart/form-data'}\r\n\t\t\t\t}\r\n\t\t\t\t// 进行ajax上传\r\n\t\t\t\tthis.$axios.post(obj.host, params, config).then(res => {\r\n\t\t\t\t\tif (res.status === 200) {\r\n\t\t\t\t\t\t// OSS上传成功后将服务器返回的图片地址替换原有地址\r\n\t\t\t\t\t\tthis.imgUrl = obj.cdn + '/' + name + '?t=' + Math.random()\r\n\t\t\t\t\t} else {\r\n\t\t\t\t\t\talert(res.statusText)\r\n\t\t\t\t\t}\r\n\t\t\t\t}).catch(error => {\r\n\t\t\t\t\talert(error)\r\n\t\t\t\t})\r\n\t\t\t},\r\n\t\t\t// 对图片进行压缩\r\n\t\t\tcompress (img) {\r\n\t\t\t\tlet canvas = document.createElement('canvas')\r\n\t\t\t\tlet ctx = canvas.getContext('2d')\r\n\t\t\t\tlet width = img.width\r\n\t\t\t\tlet height = img.height\r\n\t\t\t\t// 进行生成图片尺寸计算\r\n\t\t\t\tif (this.width > 0 && width > this.width) {\r\n\t\t\t\t\t// 限定宽度\r\n\t\t\t\t\tcanvas.width = this.width\r\n\t\t\t\t\tcanvas.height = height * (this.width / width)\r\n\t\t\t\t} else if (this.height > 0 && height > this.height) {\r\n\t\t\t\t\t// 限定高度\r\n\t\t\t\t\tcanvas.height = this.height\r\n\t\t\t\t\tcanvas.width = width * (this.height / height)\r\n\t\t\t\t} else {\r\n\t\t\t\t\t// 不限定尺寸\r\n\t\t\t\t\tcanvas.width = width\r\n\t\t\t\t\tcanvas.height = height\r\n\t\t\t\t}\r\n\t\t\t\t// 铺底色\r\n\t\t\t\tctx.fillStyle = '#fff'\r\n\t\t\t\tctx.fillRect(0, 0, canvas.width, canvas.height)\r\n\t\t\t\tctx.drawImage(img, 0, 0, canvas.width, canvas.height)\r\n\t\t\t\t// 进行最小压缩\r\n\t\t\t\tlet ndata = canvas.toDataURL('image/jpeg', this.ratio)\r\n\t\t\t\treturn ndata\r\n\t\t\t},\r\n\t\t\t// base64转成bolb对象\r\n\t\t\tdataURItoBlob (base64Data) {\r\n\t\t\t\tvar byteString\r\n\t\t\t\tif (base64Data.split(',')[0].indexOf('base64') >= 0) {\r\n\t\t\t\t\tbyteString = atob(base64Data.split(',')[1])\r\n\t\t\t\t} else {\r\n\t\t\t\t\tbyteString = unescape(base64Data.split(',')[1])\r\n\t\t\t\t}\r\n\t\t\t\tvar mimeString = base64Data.split(',')[0].split(':')[1].split(';')[0]\r\n\t\t\t\tvar ia = new Uint8Array(byteString.length)\r\n\t\t\t\tfor (var i = 0; i < byteString.length; i++) {\r\n\t\t\t\t\tia[i] = byteString.charCodeAt(i)\r\n\t\t\t\t}\r\n\t\t\t\treturn new Blob([ia], { type: mimeString })\r\n\t\t\t},\r\n\t\t\t// 生成随机字符串，用于图片命名\r\n\t\t\trandomString (len) {\r\n\t\t\t\tlen = len || 32\r\n\t\t\t\tvar chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678'\r\n\t\t\t\tvar maxPos = chars.length\r\n\t\t\t\tvar pwd = ''\r\n\t\t\t\tfor (let i = 0; i < len; i++) {\r\n\t\t\t\t\tpwd += chars.charAt(Math.floor(Math.random() * maxPos))\r\n\t\t\t\t}\r\n\t\t\t\treturn pwd\r\n\t\t\t},\r\n\t\t\t// 获取文件扩展名\r\n\t\t\tgetSuffix (filename) {\r\n\t\t\t\tlet pos = filename.lastIndexOf('.')\r\n\t\t\t\tlet suffix = ''\r\n\t\t\t\tif (pos !== -1) {\r\n\t\t\t\t\tsuffix = filename.substring(pos)\r\n\t\t\t\t}\r\n\t\t\t\treturn suffix.toLowerCase()\r\n\t\t\t}\r\n\t\t},\r\n\t\tdata () {\r\n\t\t\treturn {\r\n\t\t\t\timgUrl: ''\r\n\t\t\t}\r\n\t\t}\r\n\t}\r\n</script>\r\n\r\n<style scoped>\r\n\t.z_up-btn {\r\n\t\tposition: relative;\r\n\t\tdisplay: flex;\r\n\t\tjustify-content: center;\r\n\t\talign-items: center;\r\n\t\tmin-height: 100px;\r\n\t\tborder: 1px solid #dcdee2;\r\n\t\tcursor: pointer;\r\n\t}\r\n\t.z_up-btn img {\r\n\t\tmax-width: 100%;\r\n\t\tmax-height: 100%;\r\n\t}\r\n\t.z_add-btn {\r\n\t\tposition: absolute;\r\n\t\ttop: 0;\r\n\t\tleft: 0;\r\n\t\tright: 0;\r\n\t\tbottom: 0;\r\n\t\tz-index: 99;\r\n\t}\r\n\t.z_add-tips {\r\n\t\tfont-size: 14px;\r\n\t\tcolor: #ccc;\r\n\t}\r\n</style>\r\n"],"sourceRoot":""}]);

// exports


/***/ }),
/* 5 */
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
  Modified by Evan You @yyx990803
*/

var hasDocument = typeof document !== 'undefined'

if (typeof DEBUG !== 'undefined' && DEBUG) {
  if (!hasDocument) {
    throw new Error(
    'vue-style-loader cannot be used in a non-browser environment. ' +
    "Use { target: 'node' } in your Webpack config to indicate a server-rendering environment."
  ) }
}

var listToStyles = __webpack_require__(7)

/*
type StyleObject = {
  id: number;
  parts: Array<StyleObjectPart>
}

type StyleObjectPart = {
  css: string;
  media: string;
  sourceMap: ?string
}
*/

var stylesInDom = {/*
  [id: number]: {
    id: number,
    refs: number,
    parts: Array<(obj?: StyleObjectPart) => void>
  }
*/}

var head = hasDocument && (document.head || document.getElementsByTagName('head')[0])
var singletonElement = null
var singletonCounter = 0
var isProduction = false
var noop = function () {}
var options = null
var ssrIdKey = 'data-vue-ssr-id'

// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
// tags it will allow on a page
var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\b/.test(navigator.userAgent.toLowerCase())

module.exports = function (parentId, list, _isProduction, _options) {
  isProduction = _isProduction

  options = _options || {}

  var styles = listToStyles(parentId, list)
  addStylesToDom(styles)

  return function update (newList) {
    var mayRemove = []
    for (var i = 0; i < styles.length; i++) {
      var item = styles[i]
      var domStyle = stylesInDom[item.id]
      domStyle.refs--
      mayRemove.push(domStyle)
    }
    if (newList) {
      styles = listToStyles(parentId, newList)
      addStylesToDom(styles)
    } else {
      styles = []
    }
    for (var i = 0; i < mayRemove.length; i++) {
      var domStyle = mayRemove[i]
      if (domStyle.refs === 0) {
        for (var j = 0; j < domStyle.parts.length; j++) {
          domStyle.parts[j]()
        }
        delete stylesInDom[domStyle.id]
      }
    }
  }
}

function addStylesToDom (styles /* Array<StyleObject> */) {
  for (var i = 0; i < styles.length; i++) {
    var item = styles[i]
    var domStyle = stylesInDom[item.id]
    if (domStyle) {
      domStyle.refs++
      for (var j = 0; j < domStyle.parts.length; j++) {
        domStyle.parts[j](item.parts[j])
      }
      for (; j < item.parts.length; j++) {
        domStyle.parts.push(addStyle(item.parts[j]))
      }
      if (domStyle.parts.length > item.parts.length) {
        domStyle.parts.length = item.parts.length
      }
    } else {
      var parts = []
      for (var j = 0; j < item.parts.length; j++) {
        parts.push(addStyle(item.parts[j]))
      }
      stylesInDom[item.id] = { id: item.id, refs: 1, parts: parts }
    }
  }
}

function createStyleElement () {
  var styleElement = document.createElement('style')
  styleElement.type = 'text/css'
  head.appendChild(styleElement)
  return styleElement
}

function addStyle (obj /* StyleObjectPart */) {
  var update, remove
  var styleElement = document.querySelector('style[' + ssrIdKey + '~="' + obj.id + '"]')

  if (styleElement) {
    if (isProduction) {
      // has SSR styles and in production mode.
      // simply do nothing.
      return noop
    } else {
      // has SSR styles but in dev mode.
      // for some reason Chrome can't handle source map in server-rendered
      // style tags - source maps in <style> only works if the style tag is
      // created and inserted dynamically. So we remove the server rendered
      // styles and inject new ones.
      styleElement.parentNode.removeChild(styleElement)
    }
  }

  if (isOldIE) {
    // use singleton mode for IE9.
    var styleIndex = singletonCounter++
    styleElement = singletonElement || (singletonElement = createStyleElement())
    update = applyToSingletonTag.bind(null, styleElement, styleIndex, false)
    remove = applyToSingletonTag.bind(null, styleElement, styleIndex, true)
  } else {
    // use multi-style-tag mode in all other cases
    styleElement = createStyleElement()
    update = applyToTag.bind(null, styleElement)
    remove = function () {
      styleElement.parentNode.removeChild(styleElement)
    }
  }

  update(obj)

  return function updateStyle (newObj /* StyleObjectPart */) {
    if (newObj) {
      if (newObj.css === obj.css &&
          newObj.media === obj.media &&
          newObj.sourceMap === obj.sourceMap) {
        return
      }
      update(obj = newObj)
    } else {
      remove()
    }
  }
}

var replaceText = (function () {
  var textStore = []

  return function (index, replacement) {
    textStore[index] = replacement
    return textStore.filter(Boolean).join('\n')
  }
})()

function applyToSingletonTag (styleElement, index, remove, obj) {
  var css = remove ? '' : obj.css

  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = replaceText(index, css)
  } else {
    var cssNode = document.createTextNode(css)
    var childNodes = styleElement.childNodes
    if (childNodes[index]) styleElement.removeChild(childNodes[index])
    if (childNodes.length) {
      styleElement.insertBefore(cssNode, childNodes[index])
    } else {
      styleElement.appendChild(cssNode)
    }
  }
}

function applyToTag (styleElement, obj) {
  var css = obj.css
  var media = obj.media
  var sourceMap = obj.sourceMap

  if (media) {
    styleElement.setAttribute('media', media)
  }
  if (options.ssrId) {
    styleElement.setAttribute(ssrIdKey, obj.id)
  }

  if (sourceMap) {
    // https://developer.chrome.com/devtools/docs/javascript-debugging
    // this makes source maps inside style tags work properly in Chrome
    css += '\n/*# sourceURL=' + sourceMap.sources[0] + ' */'
    // http://stackoverflow.com/a/26603875
    css += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + ' */'
  }

  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = css
  } else {
    while (styleElement.firstChild) {
      styleElement.removeChild(styleElement.firstChild)
    }
    styleElement.appendChild(document.createTextNode(css))
  }
}


/***/ }),
/* 7 */
/***/ (function(module, exports) {

/**
 * Translates the list format produced by css-loader into something
 * easier to manipulate.
 */
module.exports = function listToStyles (parentId, list) {
  var styles = []
  var newStyles = {}
  for (var i = 0; i < list.length; i++) {
    var item = list[i]
    var id = item[0]
    var css = item[1]
    var media = item[2]
    var sourceMap = item[3]
    var part = {
      id: parentId + ':' + i,
      css: css,
      media: media,
      sourceMap: sourceMap
    }
    if (!newStyles[id]) {
      styles.push(newStyles[id] = { id: id, parts: [part] })
    } else {
      newStyles[id].parts.push(part)
    }
  }
  return styles
}


/***/ }),
/* 8 */
/***/ (function(module, exports) {

/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file.
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

module.exports = function normalizeComponent (
  rawScriptExports,
  compiledTemplate,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier /* server only */
) {
  var esModule
  var scriptExports = rawScriptExports = rawScriptExports || {}

  // ES6 modules interop
  var type = typeof rawScriptExports.default
  if (type === 'object' || type === 'function') {
    esModule = rawScriptExports
    scriptExports = rawScriptExports.default
  }

  // Vue.extend constructor export interop
  var options = typeof scriptExports === 'function'
    ? scriptExports.options
    : scriptExports

  // render functions
  if (compiledTemplate) {
    options.render = compiledTemplate.render
    options.staticRenderFns = compiledTemplate.staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = scopeId
  }

  var hook
  if (moduleIdentifier) { // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = injectStyles
  }

  if (hook) {
    var functional = options.functional
    var existing = functional
      ? options.render
      : options.beforeCreate

    if (!functional) {
      // inject component registration as beforeCreate hook
      options.beforeCreate = existing
        ? [].concat(existing, hook)
        : [hook]
    } else {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functioal component in vue file
      options.render = function renderWithStyleInjection (h, context) {
        hook.call(context)
        return existing(h, context)
      }
    }
  }

  return {
    esModule: esModule,
    exports: scriptExports,
    options: options
  }
}


/***/ }),
/* 9 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c("div", [
    _c("div", { staticClass: "z_up-btn", style: _vm.boxStyle }, [
      _c("div", { staticClass: "z_add-btn", on: { click: _vm.chooseFile } }, [
        _c("input", {
          staticStyle: { display: "none" },
          attrs: { type: "file", id: _vm.dom, accept: "image/*" },
          on: {
            change: function($event) {
              return _vm.fileChange($event)
            }
          }
        })
      ]),
      _vm._v(" "),
      _vm.isShow ? _c("img", { attrs: { src: _vm.addIcon } }) : _vm._e(),
      _vm._v(" "),
      !_vm.isShow
        ? _c("img", { attrs: { src: _vm.imgUrl, alt: "图片数据丢失" } })
        : _vm._e()
    ])
  ])
}
var staticRenderFns = []
render._withStripped = true
var esExports = { render: render, staticRenderFns: staticRenderFns }
/* harmony default export */ __webpack_exports__["a"] = (esExports);
if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-5ef48958", esExports)
  }
}

/***/ })
/******/ ]);
});
//# sourceMappingURL=OSUpload.js.map